# Workflow ## List Pending Approvals - [POST /workflowsmanager.fetch/active](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-workflowsmanager.fetch-active.md): Retrieves a list of all authenticated user's approvals. Available for the following roles: - ADMIN_WO_USER_MGMT (General Admin (without User Management)) - SUPPORT (Investigate for Support) - PRICESHOP_RO (View Quoting) - PRICESHOP_EDIT (Edit Quoting) - PB_PRICEGRIDS_RO (View LPG) - WF_BUILDER (Manage Workflow Logics) - RM_RAT (Manage Rebate Templates) - RM_REBATEAGREEMENTS_RO (View Rebate Agreements) - RM_REBATEAGREEMENTS (Manage Rebate Agreements) - WF_BUILDER (Manage Workflow Logics) - CONTRACTS_RO (View A&P) - CM_CONTRACTMANAGER (Manage A&P module) - CONTRACTS_RO (View A&P) - WF_ADMIN (Manage Workflows) - SC_COMPENSATIONS_RO (View Compensation Plans) - SC_ADMIN (Administer Sales Compensations module) ## List User's Pending Approvals - [POST /workflowsmanager.fetchfilteredbyapprovable/active/{loginName}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-workflowsmanager.fetchfilteredbyapprovable-active-loginname.md): Retrieves a list of Pending Approvals for the particular user. ## List Workflows - [POST /workflowsmanager.fetch](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-workflowsmanager.fetch.md): Retrieves a list of workflows (based on filter settings) where the authenticated user participates. The request can be sent also with an empty body (without filters or paging) in order to retrieve all workflows. Returns all workflows if the authenticated user is the workflow admin. --- Filter example: Returns only workflows where document type = Quote and workflow status = Approved. json { "data":{ "_constructor":"AdvancedCriteria", "operator":"and", "criteria":[ { "fieldName":"code", "operator":"equals", "value":"Q" }, { "fieldName":"workflowStatus", "operator":"equals", "value":"APPROVED" } ] } } Available for the following roles: - ADMIN_WO_USER_MGMT (General Admin (without User Management)) - SUPPORT (Investigate for Support) - PRICESHOP_RO (View Quoting) - PRICESHOP_EDIT (Edit Quoting) - PB_PRICEGRIDS_RO (View LPG) - WF_BUILDER (Manage Workflow Logics) - RM_RAT (Manage Rebate Templates) - RM_REBATEAGREEMENTS_RO (View Rebate Agreements) - RM_REBATEAGREEMENTS (Manage Rebate Agreements) - WF_BUILDER (Manage Workflow Logics) - CONTRACTS_RO (View A&P) - CM_CONTRACTMANAGER (Manage A&P module) - CONTRACTS_RO (View A&P) - WF_ADMIN (Manage Workflows) - SC_COMPENSATIONS_RO (View Compensation Plans) - SC_ADMIN (Administer Sales Compensations module) ## Get a Workflow Document - [POST /workflowsmanager.fetchdetailsviaapprovable/{typedId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-workflowsmanager.fetchdetailsviaapprovable-typedid.md): Retrieves workflow details of the approvable object. See the Workflows article to find out which documents types can have approval workflows. Available for the following roles: - ADMIN_WO_USER_MGMT (General Admin (without User Management)) - SUPPORT (Investigate for Support) - PRICESHOP_RO (View Quoting) - PB_PRICELISTS_RO (View Price Lists) - PB_PRICEGRIDS_RO (View LPG) - RM_REBATEAGREEMENTS_RO (View Rebate Agreements) - RM_REBATEAGREEMENTS (Manage Rebate Agreements) - RM_REBATERECORDS (Manage Rebate Records) - RM_REBATERECORDS_RO (View Rebate Records) - CONTRACTS_RO (View A&P) - CM_CONTRACTS (Manage A&P) - CLM_CLAIM (Use Claims) - WF_ADMIN (Manage Workflows) - PO_MODELRECORDS_RO (View Policy Records) - PO_MODELRECORDS_APPROVAL (Approve Policy Records) - MODULECATEGORY_MO_RO (View Model in Module Category) - SC_COMPENSATIONS_RO (View Compensation Plans) ## Approve a Document - [POST /workflowsmanager.approve/{currentStepId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-workflowsmanager.approve-currentstepid.md): Approves a document specified by the currentStepId. Allows you to add a comment in the request body. ## Deny a Document - [POST /workflowsmanager.deny/{currentStepId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-workflowsmanager.deny-currentstepid.md): Denies a document specified by the currentStepId. Allows you to add a comment in the request body. ## Withdraw a Document - [POST /workflowsmanager.withdraw/{currentStepId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-workflowsmanager.withdraw-currentstepid.md): Withdraws the document from the approval workflow (specified by the currentStepId). ## Add an Approver Step - [POST /workflowsmanager.addapprover/{currentStepId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-workflowsmanager.addapprover-currentstepid.md): Adds an approver step to the workflow (specified by the currentStepId). ## Add a Watcher Step - [POST /workflowsmanager.addwatcher/{currentStepId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-workflowsmanager.addwatcher-currentstepid.md): Adds a watcher step to the workflow (specified by the currentStepId). ## Update a Review Status - [POST /review.update/{typedId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-review.update-typedid.md): > This feature is experimental in version 14.0 - Caribou Lou. Updates the review status of the specified line items in the Review step of the Collaboration Workflow. The request can only be executed by a member of the User Group that is currently authorized to review the associated input fields, as defined in the Creation Workflow configuration. If the user does not have the required permissions, the request will fail. ## Set a Review as Done - [POST /review.done/{typedId}](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-review.done-typedid.md): > This feature is experimental in version 14.0 - Caribou Lou. Completes the review of line items in the Review step of the Collaboration workflow. Only members of the User Group currently authorized by the Creation Workflow configuration can execute this request; otherwise, the request will fail. ## Fetch Pending Reviews - [POST /review.fetchpendingreviews](https://api.pricefx.com/openapi/reference/pricefx-server_openapi/workflow/post-review.fetchpendingreviews.md): Fetches a list of pending collaboration workflow reviews for the current user.